accountent/urls.py
import os
from django.conf.urls import url
from django.contrib.auth.decorators import login_required

from . import views, wizards

app_name = "accountent"

urlpatterns = []

if os.environ.get('POSTGRES_HOST', False):
    from hordak import views as hordak_views

    urlpatterns += [
        url(r'^wizard/register/$', wizards.RegisterWizard.as_view(), name='register_wizard'),
        url(r'^wizard/transactions/create/$', wizards.TransactionCreateWizard.as_view(), name='transactions_create_wizard'),
        #url(r'^wizard/transactions/reconcile/$', wizards.TransactionReconcileWizard.as_view(), name='transactions_reconcile_wizard'),
        url(r'^transactions/$', views.TransactionListView.as_view(), name='transactions_list'),
        url(r'^transactions/create/$', hordak_views.TransactionCreateView.as_view(), name='transactions_create'),
        url(r'^transactions/currency/$', hordak_views.CurrencyTradeView.as_view(), name='currency_trade'),
        url(r'^transactions/reconcile/$', views.TransactionReconcileListView.as_view(), name='transactions_reconcile'),
        url(r'^transactions/sync/$', views.SyncTransactionView.as_view(), name='transactions_sync'),
        url(r'^account/$', views.AccountListView.as_view(), name='accounts_list'),
        url(r'^account/bank/$', views.BankAccountListView.as_view(), name='bank_account_list'),
        url(r'^account/bank/create/$', views.BankAccountCreateView.as_view(), name='bank_account_create'),
        url(r'^account/bank/import/create/$', views.BankAccountCreateImportView.as_view(), name='bank_import_create'),
        url(r'^account/bank/import/(?P<uuid>.*)/setup/$', views.BankAccountSetupView.as_view(), name='bank_import_setup'),
        url(r'^account/bank/import/(?P<uuid>.*)/dry-run/$', views.BankDryRunImportView.as_view(), name='bank_import_dry_run'),
        url(r'^account/bank/import/(?P<uuid>.*)/run/$', views.BankExecuteImportView.as_view(), name='bank_import_execute'),
        url(r'^account/bank/(?P<code>.*)/$', views.BankAccountDetailView.as_view(), name='bank_account_detail'),
        url(r'^account/create/$', views.AccountCreateView.as_view(), name='accounts_create'),
        url(r'^account/update/(?P<uuid>.+)/$', hordak_views.AccountUpdateView.as_view(), name='accounts_update'),
        url(r'^account/(?P<uuid>.+)/$', views.AccountDetailView.as_view(), name='accounts_transactions'),
        url(r'^settings/VAT/codes/$',views.VATCodeModelListView.as_view(), name='vat_code_list'),
        url(r'^$', login_required(views.main), name='main'),
    ]

web_mvc/urls.py
# -*- coding: utf-8 -*-
from __future__ import absolute_import, print_function, unicode_literals
import os
from cms.sitemaps import CMSSitemap
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.views.static import serve

admin.autodiscover()

urlpatterns = [
    url(r'^sitemap\.xml$', sitemap,
        {'sitemaps': {'cmspages': CMSSitemap}}),
]

urlpatterns += i18n_patterns(
    url(r'^admin/', admin.site.urls),  # NOQA
    url(r'^accounts/', include('allauth.urls')),
    url(r'^dashboard/', include('dashboard.urls')),
)

if os.environ.get('POSTGRES_HOST', False):
    urlpatterns += i18n_patterns(
        url(r'^accounting/hordak/', include('hordak.urls', namespace='hordak')),
        url(r'^accounting/VAT/', include('vat.urls')),
        url(r'^accounting/', include('accountent.urls')),
    )

urlpatterns += i18n_patterns(
    url(r'^', include('cms.urls')),
)

# This is only needed when using runserver.
if settings.DEBUG:
    urlpatterns = [
        url(r'^media/(?P<path>.*)$', serve,
            {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}),
        ] + staticfiles_urlpatterns() + urlpatterns

accountent/forms.py
from django import forms
from django.conf import settings
from django.utils.translation import ugettext_lazy as _
from hordak.forms.accounts import AccountForm
from hordak.forms import statement_csv_import as hordak_statement_forms
from hordak import forms as hordak_forms
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Fieldset
from hordak import models as hordak_models
#from django_iban.fields import IBANField, SWIFTBICField
from localflavor.generic.forms import BICFormField, IBANFormField

from . import models


class accountentSettingsForm(forms.ModelForm):

    class Meta:
        model = models.accountentSettings
        exclude = (
            'company', 
        )

class TransactionTypeModelForm(forms.ModelForm):
    
    class Meta:
        model = models.TransactionModel
        fields = (
            'code_type',
        )

class TransactionVATCodeModelForm(forms.ModelForm):
    
    class Meta:
        model = models.TransactionModel
        fields = (
            'code',
        )

class BaseTransactionAccountForm(hordak_forms.SimpleTransactionForm):
    pass

class CreateBankAccountForm(forms.Form):
    name = forms.CharField(max_length=50, label=_("Account name"), help_text=_("This name will be used for accountent purposes"))
    iban_number = IBANFormField(label=_('Account number (IBAN)'), help_text=_("e.g {country_code}[0-9]*25"))
    swift_bic = BICFormField(label=_('Bank SWIFT / BIC'))
    bank_name = forms.CharField(max_length=255, label=_("Bank name"), help_text=_("This name will be used for invoices purposes"))

#BankTransactionCsvImportFormSet = forms.inlineformset_factory(form=ImportBankAccountForm, extra=1, can_delete=True)


class BankTransactionCsvImportFormHelper(FormHelper):
    def __init__(self, *args, **kwargs):
        super(BankTransactionCsvImportFormHelper, self).__init__(*args, **kwargs)
        self.form_tag = False
        self.layout = Layout(
            Fieldset(_("Bank statement csv file"), 'file'),
            Fieldset(_("Has headings"), 'has_headings'),
        )


class BankTransactionCsvImportForm(hordak_statement_forms.TransactionCsvImportForm):

    @property
    def helper(self):
        helper = BankTransactionCsvImportFormHelper()
        helper.form_tag = False

        return helper
    
    def save(self, commit=True):
        form_data = super(BankTransactionCsvImportForm, self).save(commit=False)

        accounts = utils.get_bank_accounts()

        form_data['accounts'] = accounts

        return form_data.save(commit=commit)
        
    def is_valid(self):
        return super().is_valid()

#BankTransactionCsvImportFormSet = forms.models.inlineformset_factory(parent_model=hordak_models.Account, model=hordak_statement_forms.TransactionCsvImport, form=BankTransactionCsvImportForm, fields=('file', 'has_headings'), extra=1, can_delete=True)

BankTransactionCsvImportColumnFormSet = hordak_statement_forms.TransactionCsvImportColumnFormSet()

class SelectReconcileTransactionModelForm(forms.Form):
    #transaction = forms.MultipleChoiceField(choices=transaction_choices, label=_("Transactions"), widget=forms.CheckboxSelectMultiple())
    pass

class CreateReconcileTransactionModelForm():
    pass

class VATReconcileTransactionModelForm():
    pass

accountent/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.urls import reverse_lazy
from django import views
from django.conf import settings
from django.views.generic import ListView, CreateView, FormView, DetailView
from django.utils.translation import ugettext_lazy as _
from formtools.wizard.views import SessionWizardView
from vat.models import CompanyModel
from django.db import transaction as db_transaction

from hordak import models as hordak_models
from hordak import views as hordak_views
from moneyed import Money

from . import forms
from . import models
from . import utils

def main(request):
    context = {}
    company = CompanyModel.objects.all().first()
    if company != None:
        settings = models.accountentSettings.objects.filter(company=company).first()
        if settings != None:
            bank_account_list = utils.get_bank_accounts()
            if bank_account_list != None:
                return render(request, "accountent/main.html", context=context)
            else:
                redirect(reverse_lazy("accountent:bank_account_list"))
        
    return redirect(reverse_lazy('accountent:register_wizard'))

class AccountCreateView(hordak_views.AccountCreateView):
    template_name = "accountent/account_create.html"

class AccountDetailView(hordak_views.AccountTransactionsView):
    template_name = "accountent/account_detail.html"

class BankAccountDetailView(DetailView):
    model = models.BankAccount
    template_name = "accountent/bank_account_detail.html"

    def get_queryset(self):
        """
        Return the `QuerySet` that will be used to look up the object.
        Note that this method is called by the default implementation of
        `get_object` and may not be called if `get_object` is overridden.
        """
        if self.queryset is None:
            if self.model:
                return self.model._default_manager.all()
            else:
                raise ImproperlyConfigured(
                    "%(cls)s is missing a QuerySet. Define "
                    "%(cls)s.model, %(cls)s.queryset, or override "
                    "%(cls)s.get_queryset()." % {
                        'cls': self.__class__.__name__
                    }
                )
        bank_parent = hordak_models.Account.objects.filter(full_code=102).first()
        return self.queryset.filter(parent=bank_parent).all()

    def get_object(self, queryset=None):
        """
        Returns the object the view is displaying.
        By default this requires `self.queryset` and a `code` argument
        in the URLconf, but subclasses can override this to return any object.
        """
        # Use a custom queryset if provided; this is required for subclasses
        # like DateDetailView
        if queryset is None:
            queryset = self.get_queryset()
        # Next, try looking up by code.
        code = self.kwargs.get('code')
        if code is not None:
            queryset = queryset.filter(account__code=code)
        
        # If none of those are defined, it's an error.
        if code is None:
            raise AttributeError("Generic detail view %s must be called with "
                                "either an object code."
                                % self.__class__.__name__)
        try:
            # Get the single item from the filtered queryset
            obj = queryset.get()
        except queryset.model.DoesNotExist:
            raise Http404(_("No %(verbose_name)s found matching the query") %
                        {'verbose_name': queryset.model._meta.verbose_name})
        return obj

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        # Add legs for account
        context['legs'] = hordak_models.Leg.objects.filter(account=self.object.account)
        return context

class BankAccountCreateView(FormView):
    form_class = forms.CreateBankAccountForm
    template_name = "accountent/bank_account_create.html"
    success_url = reverse_lazy('accountent:bank_account_list')

    def form_valid(self, form):
        is_valid = super().form_valid(form)
        if is_valid:
            #create account
            account_name = form.cleaned_data.get('name')
            account_obj = utils.create_bank_account(account_name)

            #create bank
            bank_name = form.cleaned_data.get('bank_name')
            bank_obj, _ = models.Bank.objects.get_or_create(name=bank_name)

            #create bank account
            iban_num = form.cleaned_data.get('iban_number')
            swift_bic = form.cleaned_data.get('swift_bic')
            bank_account_obj = models.BankAccount.objects.create(account=account_obj, bank=bank_obj, iban=iban_num, swift_bic=swift_bic)

            return redirect(reverse_lazy("accountent:bank_account_detail", kwargs={'code':account_obj.code}))

        return is_valid

class BankAccountCreateImportView(hordak_views.statement_csv_import.CreateImportView):
    template_name = "accountent/statement_import/import_create.html"
    #success_url = reverse_lazy('accountent:bank_account_list')
    #form_class = forms.BankTransactionCsvImportForm
        
    def get_success_url(self):
        return reverse_lazy("accountent:bank_import_setup", args=[self.object.uuid])


class AccountListView(hordak_views.AccountListView):
    template_name = "accountent/account_list.html"
    paginate_by = 10

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['active_id'] = "accounts-list"
        return context

class BankAccountListView(hordak_views.AccountListView):
    template_name = "accountent/bank_account_list.html"
    paginate_by = 10

    def get_queryset(self):
        parent = hordak_models.Account.objects.filter(full_code=102).first()
        queryset = hordak_models.Account.objects.filter(parent=parent, is_bank_account=True)
        return queryset #super().get_queryset()
    

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['active_id'] = "bank-list"
        return context

   
class BankAccountSetupView(hordak_views.statement_csv_import.SetupImportView):
    template_name = "accountent/statement_import/import_setup.html"

    def get_success_url(self):
        return reverse_lazy("accountent:bank_import_dry_run", args=[self.object.uuid])

class BankDryRunImportView(hordak_views.statement_csv_import.DryRunImportView):
    template_name = "accountent/statement_import/import_dry_run.html"
    
    def get_success_url(self):
        return reverse_lazy("accountent:bank_import_execute", args=[self.object.uuid])

class BankExecuteImportView(hordak_views.statement_csv_import.ExecuteImportView):
    template_name = "accountent/statement_import/import_execute.html"

    def get_success_url(self):
        return reverse_lazy("accountent:main")

class TransactionReconcileListView(hordak_views.TransactionsReconcileView):
    template_name = "accountent/transactions/reconcile.html"

class SyncTransactionView(views.generic.RedirectView):

    pattern_name = 'accountent:transactions_list'

    def get_statement_line(self):
        sl = hordak_models.StatementLine.objects.order_by('date').all()
        unreconciled_sl = [x for x in sl if not x.is_reconciled]
        if len(unreconciled_sl) > 0:
            return unreconciled_sl[0]
        return None

    def get_redirect_url(self, *args, **kwargs):
        if self.get_statement_line():
            return reverse_lazy('accountent:transactions_reconcile_wizard')
        return super(SyncTransactionView, self).get_redirect_url(*args, **kwargs)

class TransactionListView(ListView):
    template_name = "accountent/transactions_list.html"
    model = hordak_models.Transaction
    list_display = [
        "pk",
        "timestamp",
        "debited_accounts",
        "credited_accounts",
        "total_amount",
    ]
    readonly_fields = ("timestamp",)
    search_fields = (
        "legs__account__name",
    )
    paginate_by = 10

    def debited_accounts(self, obj):
        return ", ".join([str(leg.account) for leg in obj.legs.debits()]) or None

    def credited_accounts(self, obj):
        return ", ".join([str(leg.account) for leg in obj.legs.credits()]) or None

    def total_amount(self, obj):
        return obj.legs.debits().aggregate(Sum("amount"))["amount__sum"]

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['active_id'] = "transactions-journal"
        return context

class VATCodeModelListView(ListView):
    model = models.VATCodeModel
    template_name = "accountent/vat_code_list.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['active_id'] = "vat-code-list"
        return context

accountent/templates/accountent/includes/navbar.html
{% load i18n %}

<style>
    ul.navbar-nav  div.dropdown-menu {
        left: 0!important;
    }

    @media (min-width: 768px) { 
        ul.navbar-nav div.dropdown-menu {
            left: auto!important;
        }
    }
</style>

<div class="main-navbar sticky-top bg-white">
    <!-- Main Navbar -->
    <nav class="navbar align-items-stretch navbar-light flex-md-nowrap p-0">
        <div class="w-100 f-flex"></div>
        <ul class="navbar-nav border-left flex-row">
            <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle text-nowrap px-3 pt-4" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">
                    <span class="d-inline-block">{% if request.user.get_full_name %}{{ request.user.get_full_name }}{% else %}{{ request.user.username }}{% endif %}</span>
                </a>
                <div class="dropdown-menu dropdown-menu-small">
                    <div class="dropdown-divider"></div>
                    <a class="dropdown-item text-danger" href="{% url 'account_logout' %}">
                        <i class="fas fa-sign-out-alt"></i> Logout </a>
                </div>
            </li>
        </ul>
        <nav class="nav">
            <a href="#" class="nav-link nav-link-icon toggle-sidebar d-sm-inline d-md-none text-center border-left" data-toggle="collapse" data-target=".header-navbar" aria-expanded="false" aria-controls="header-navbar">
                <i class="fas fa-bars"></i>
            </a>
        </nav>
    </nav>
</div>
<!-- / .main-navbar -->

accountent/templates/accountent/includes/sidebar.html
{% load staticfiles i18n sekizai_tags %}
<!-- Main Sidebar -->
<aside class="main-sidebar col-12 col-md-3 col-lg-2 px-0">
    <div class="main-navbar">
        <nav class="navbar align-items-stretch navbar-light bg-white flex-md-nowrap border-bottom p-0">
            <a class="navbar-brand w-100 mr-0" href="{% url 'accountent:main' %}" style="line-height: 25px;">
                <div class="d-table m-auto">
                    <span class="d-inline ml-1">{% trans "accountent" %}</span>
                </div>
            </a>
            <a class="toggle-sidebar d-sm-inline d-md-none d-lg-none">
                <i class="fas fa-chevron-left"></i>
            </a>
        </nav>
    </div>
    <div class="nav-wrapper">
        <h6 class="main-sidebar__nav-title d-flex align-items-center justify-content-between">
            {% trans "Accounts" %}
            <div class="row align-items-center justify-content-end">
                <a href="{% url 'accountent:accounts_create' %}" class="btn btn-sm btn-default btn-pill d-flex justify-content-end align-items-center px-1">
                    <i class="fas fa-plus d-inline-block"></i> 
                    <span class="d-inline d-md-none d-lg-none d-xl-none">{% trans "New account" %}</span>
                </a>    
            </div>
        </h6>
        <ul class="nav nav--no-borders flex-column">
            <li class="nav-item" id="sidebar-item-accounts-list">
                <a class="nav-link" href="{% url 'accountent:accounts_list' %}">
                    <i class="fas fa-book"></i>
                    <span>{% trans "Books" %}</span>
                </a>
            </li>
            <li class="nav-item" id="sidebar-item-bank-list">
                <a class="nav-link" href="{% url 'accountent:bank_account_list' %}">
                    <i class="fas fa-piggy-bank"></i>
                    <span>{% trans "Bank" %}</span>
                </a>
            </li>
        </ul>
        <h6 class="main-sidebar__nav-title d-flex align-items-center justify-content-between">
            {% trans "Transactions" %}
            <div class="row align-items-center justify-content-end">
                <a href="{% url 'accountent:bank_import_create' %}" class="btn btn-sm btn-default btn-pill d-flex justify-content-end align-items-center px-1 mr-1">
                    <i class="fas fa-file-upload d-inline-block"></i>
                    <span class="d-inline d-md-none d-lg-none d-xl-none">{% trans "Import from bank account" %}</span>
                </a>
                <a href="{% url 'accountent:transactions_create_wizard' %}" class="btn btn-sm btn-default btn-pill d-flex justify-content-end align-items-center px-1">
                    <i class="fas fa-plus d-inline-block"></i> 
                    <span class="d-inline d-md-none d-lg-none d-xl-none">{% trans "New transaction" %}</span>
                </a>    
            </div>
        </h6>
        <ul class="nav nav--no-borders flex-column">
            <li class="nav-item" id="sidebar-item-transactions-journal">
                <a class="nav-link" href="{% url 'accountent:transactions_list' %}">
                    <i class="fas fa-book-open"></i>
                    <span>{% trans "Journal" %}</span>
                </a>
            </li>
        </ul>
        <h6 class="main-sidebar__nav-title d-flex align-items-center justify-content-between">
            {% trans "VAT" %}
            <div class="row align-items-center justify-content-end">
                <a href="{% url 'accountent:vat_code_list' %}" class="btn btn-sm btn-default btn-pill d-flex justify-content-end align-items-center px-1 mr-1">
                    <i class="fas fa-cog d-inline-block"></i>
                    <span class="d-inline d-md-none d-lg-none d-xl-none">{% trans "VAT Codes" %}</span>
                </a> 
                <!-- <a href="{# % url 'vat:new-statement' % #}" class="btn btn-sm btn-default btn-pill d-flex justify-content-end align-items-center px-1">
                    <i class="fas fa-plus d-inline-block"></i> 
                    <span class="d-inline d-md-none d-lg-none d-xl-none">{% trans "New VAT statement" %}</span>
                </a>  -->
            </div>
        </h6>
        <ul class="nav nav--no-borders flex-column">
            <li class="nav-item" id="sidebar-item-vat-statement-list">
                <a class="nav-link" href="{% url 'vat:statement-list' %}">
                    <i class="fas fa-file-signature"></i>
                    <span>{% trans "Statements" %}</span>
                </a>
            </li>
            <li class="nav-item" id="sidebar-item-vat-code-list">
                <a class="nav-link" href="{% url 'accountent:vat_code_list' %}">
                    <i class="fas fa-project-diagram"></i>
                    <span>{% trans "Codes" %}</span>
                </a>
            </li>
        </ul>
    </div>
</aside>
<!-- End Main Sidebar -->

{% addtoblock "js" %}
<script type="text/javascript">
    $(document).ready(function() {
        $('#sidebar-item-{{ active_id }}').addClass("active")
    });
</script>
{% endaddtoblock %}